<template>
    <component v-bind:is="layout"></component>
</template>

<script>

    import AppLayout from "../layouts/AppLayout";
    import SimpleLayout from "../layouts/SimpleLayout";
    import axios from "axios";
    import {mapActions} from "vuex";

    export default {
        name: "App",
        computed: {
            layout() {
                return this.$store.getters.layout;
            }
        },
        components: {
            'app-layout': AppLayout,
            'simple-layout': SimpleLayout
        },
        created: function () {
            const that = this;

            axios.interceptors.response.use(undefined, function (err) {
                return new Promise(function (resolve, reject) {
                    if (err.response.status === 401 && err.config && !err.config.__isRetryRequest) {
                        that.$store.dispatch('AUTH_LOGOUT');
                    }
                    reject(err);
                    throw err;
                });
            });

            /**
             * This is used for setting the user data globally.
             *
             * @type {string}
             */
            const user = localStorage.getItem('currentUser');
            if (user) {
                this.$store.commit('SET_USER', JSON.parse(user))
            }

            const userToken = localStorage.getItem('userToken');
            if (userToken) {
                axios.defaults.headers.common['Authorization'] = 'Bearer ' + userToken;
            }



        }
    }
</script>

<style lang="scss" scoped>
    .component-fade-enter-active, .component-fade-leave-active {
        transition: opacity .3s ease;
    }

    .component-fade-enter, .component-fade-leave-to
        /* .component-fade-leave-active below version 2.1.8 */
    {
        opacity: 0;
    }
</style>